/* a) parametros generales de la gestion de puntos: se debe usar la tabla de parametros propia de prestashop */
SELECT  @max_id_configuration:=max(id_configuration)
    from ps_configuration ;

/*ojo esta tabla de parametros no admite decimales */
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 1
             ,'CONV_PU_EU' /*'Conversion de 1 Punt a euros'*/, 0.5 ,sysdate() ,sysdate()  );  

INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 2
            ,'LIM_MAX_CLI1' /*'Limite maximo de compra para cliente tipo 1-consumidor ocasional'*/, 300, sysdate() ,sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 3
   	    ,'LIM_MAX_CLI2' /*'Limite maximo de compra para cliente tipo 2-consumidor habitual'*/, 600, sysdate() ,sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 4
   	    ,'LIM_MAX_CLI3' /*'Limite maximo de compra para cliente tipo 3-superconsumidor'*/, 9999999, sysdate() ,sysdate()  );



INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 5
              ,'PTO_POR_COMPRA_CLI1' /*'Puntos por euro de compra para cliente tipo 1-consumidor ocasional'*/, 1,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 6
              ,'PTO_POR_COMPRA_CLI2' /*'Puntos por euro de compra para cliente tipo 2-consumidor habitual'*/,  2,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 7
              ,'PTO_POR_COMPRA_CLI3' /*Puntos por euro de compra para cliente tipo 3-superconsumidor'*/,  5,  sysdate() , sysdate()  );

INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration +  8 ,'CADUC_PTO_POR_COMPRA_CLI1' /*'Caducidad en dias de los puntos por euro de compra para cliente tipo 1-consumidor ocasional'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration +  9 ,'CADUC_PTO_POR_COMPRA_CLI2' /*'Caducidad en dias de los puntos por euro de compra para cliente tipo 2-consumidor habitual'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 10, 'CADUC_PTO_POR_COMPRA_CLI3' /*'Caducidad en dias de los puntos por euro de compra para cliente tipo 3-superconsumidor'*/,  360,  sysdate() , sysdate()  );


INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 11 ,'PTO_POR_APADR_APADR' /*'Puntos por euro de compra para el apadrinado'*/,  1,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 12 ,'PTO_POR_APADR_PADR_CLI1' /*'Puntos por euro de compra para el padrino tipo 1-consumidor ocasional'*/,  1,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 13 ,'PTO_POR_APADR_PADR_CLI2' /*'Puntos por euro de compra para el padrino tipo 2-consumidor habitual'*/,  2,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 14 ,'PTO_POR_APADR_PADR_CLI3' /*'Puntos por euro de compra para el padrino tipo 3-superconsumidor'*/,  5,  sysdate() , sysdate()  );

INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 15 ,'LIMIT_ECONOMIC_POR_APADRINAM' /*'Limite economico por asignacion de puntos por apadrinamiento'*/,  1000,  sysdate() , sysdate()  );

INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 16 ,'CADUC_PTO_POR_APADR_APADR' /*'Caducidad en dias de los puntos por euro de compra para el apadrinado'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 17 ,'CADUC_PTO_POR_APADR_PADR_CLI1' /*'Caducidad en dias de los puntos por euro de compra para el padrino tipo 1-consumidor ocasional'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 18 ,'CADUC_PTO_POR_APADR_PADR_CLI2' /*'Caducidad en dias de los puntos por euro de compra para el padrino tipo 2-consumidor habitual'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 19 ,'CADUC_PTO_POR_APADR_PADR_CLI3' /*'Caducidad en dias de los puntos por euro de compra para el padrino tipo 3-superconsumidor'*/,  360,  sysdate() , sysdate()  );


INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 20 ,'PTO_POR_COMENT_CLI1' /*'Puntos por euro de compra por comentario de cliente tipo 1-consumidor ocasional'*/,  1,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 21 ,'PTO_POR_COMENT_CLI2' /*'Puntos por euro de compra por comentario de cliente tipo 2-consumidor habitual'*/,  2,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 22 ,'PTO_POR_COMENT_CLI3' /*'Puntos por euro de compra por comentario de cliente tipo 3-superconsumidor'*/,  5,  sysdate() , sysdate()  );

INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 23 ,'LIMIT_ECONOMIC_POR_COMENT_CLI1' /*'Limite economico por asignacion de puntos por euro de compra por comentario de cliente tipo 1-consumidor ocasional'*/,  1000,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 24 ,'LIMIT_ECONOMIC_POR_COMENT_CLI2' /*'Limite economico por asignacion de puntos por euro de compra por comentario de cliente tipo 2-consumidor habitual'*/,  1000,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 25 ,'LIMIT_ECONOMIC_POR_COMENT_CLI3' /*'Limite economico por asignacion de puntos por euro de compra por comentario de cliente tipo 3-superconsumidor'*/,  2000,  sysdate() , sysdate()  );

INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 26 ,'CADUC_PTO_POR_COMENT_CLI1' /*'Caducidad en dias de los puntos por euro de compra por comentario de cliente tipo 1-consumidor ocasional'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 27 ,'CADUC_PTO_POR_COMENT_CLI2' /*'Caducidad en dias de los puntos por euro de compra por comentario de cliente tipo 2-consumidor habitual'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 28 ,'CADUC_PTO_POR_COMENT_CLI3' /*'Caducidad en dias de los puntos por euro de compra por comentario de cliente tipo 3-superconsumidor'*/,  360,  sysdate() , sysdate()  );


INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 29 ,'PTO_POR_ANIVERS_CLI1' /*'Puntos por euro de compra por aniversari de cliente tipo 1-consumidor ocasional'*/,  1,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 30 ,'PTO_POR_ANIVERS_CLI2' /*'Puntos por euro de compra por aniversari de cliente tipo 2-consumidor habitual'*/,  2,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 31 ,'PTO_POR_ANIVERS_CLI3' /*'Puntos por euro de compra por aniversari de cliente tipo 3-superconsumidor'*/,  5,  sysdate() , sysdate()  );

INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 32 ,'CADUC_PTO_POR_ANIVERS_CLI1' /*'Caducidad en dias de los puntos por aniversari de compra por comentario de cliente tipo 1-consumidor ocasional'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 33 ,'CADUC_PTO_POR_ANIVERS_CLI2' /*'Caducidad en dias de los puntos por aniversari de compra por comentario de cliente tipo 2-consumidor habitual'*/,  180,  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 34 ,'CADUC_PTO_POR_ANIVERS_CLI3' /*'Caducidad en dias de los puntos por aniversari de compra por comentario de cliente tipo 3-superconsumidor'*/,  360,  sysdate() , sysdate()  );



INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 35 ,'DEVOL_GRATIS_CLI1' /*'Devolucion gratis para cliente tipo 1-consumidor ocasional'*/, 'N',  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 36 ,'DEVOL_GRATIS_CLI2' /*'Devolucion gratis para cliente tipo 2-consumidor habitual'*/, 'S',  sysdate() , sysdate()  );
INSERT INTO  ps_configuration ( id_configuration, name, value, date_add , date_upd )
   VALUES (   @max_id_configuration + 37 ,'DEVOL_GRATIS_CLI3' /*'Devolucion gratis para cliente tipo 3-superconsumidor'*/, 'S',  sysdate() , sysdate()  );






/* b) parametros de puntos para las promociones especiales */
/* drop table ps_punts_promo_esp_param; */
create table ps_punts_promo_esp_param
 ( id_punts_promo_esp_param int(10)  AUTO_INCREMENT,  /* el primer campo debe ser de tipo int(10), llamarse id_nombre_tabla (sin el ps_) y ser clave primaria y de tipo  AUTO_INCREMENT */
   id_tipo_promo_esp_param  int(10),   /* tipo de promocion */
   ltDescrPromo varchar(255),  /* descripcion parametro */
   fcIni date,        /* 'NUM'-Numerico, 'STR'-String, 'FEC'-Fecha */
   fcFin date, 
   cdTipoValorControl char(3),        /* 'NUM'-Numerico, 'STR'-String, 'FEC'-Fecha */
   ltValorControlNUM decimal(20,6), 
   ltValorControlSTR char(255), 
   ltValorControlFEC date,
   nuPto_CLI1 integer,
   nuPto_CLI2 integer,
   nuPto_CLI3 integer,
   nuDiasCaduc_Pto_CLI1 integer,
   nuDiasCaduc_Pto_CLI2 integer,
   nuDiasCaduc_Pto_CLI3 integer,
   fcUpd datetime, 
   PRIMARY KEY (id_punts_promo_esp_param)
   );

/* drop table ps_tipo_promo_esp_param; */
create table ps_tipo_promo_esp_param
 ( id_tipo_promo_esp_param int(10) AUTO_INCREMENT,  /* el primer campo debe ser de tipo int(10), llamarse id_nombre_tabla (sin el ps_) y ser clave primaria y de tipo  AUTO_INCREMENT */
   ltDescrTipoPromo varchar(255),  /* descripcion del tipo de promocion */
   fcUpd datetime,
   PRIMARY KEY (id_tipo_promo_esp_param)
   );


/* 1º) tipos de promociones */
/* 1: promocion por compra minima - asignacion directa de punts */
INSERT INTO  ps_tipo_promo_esp_param ( id_tipo_promo_esp_param, ltDescrTipoPromo, fcUpd )
     VALUES ( 1, 'promocion por compra minima', sysdate()  );
/* 2: promocion por marca de zapatos - asignacion directa de punts */
INSERT INTO  ps_tipo_promo_esp_param ( id_tipo_promo_esp_param, ltDescrTipoPromo, fcUpd )
     VALUES ( 2, 'promocion por marca de zapatos', sysdate()  );
/* 3: promocion por modelo de zapatos - asignacion directa de punts */
INSERT INTO  ps_tipo_promo_esp_param ( id_tipo_promo_esp_param, ltDescrTipoPromo, fcUpd )
     VALUES ( 3, 'promocion por modelo de zapatos', sysdate()  );
/* 4: promocion por compra minima - asignacion per multiple (factor multiplicador) dels punts de la compra realitzada */
INSERT INTO  ps_tipo_promo_esp_param ( id_tipo_promo_esp_param, ltDescrTipoPromo, fcUpd )
     VALUES ( 4, 'promocion por compra minima - multiplo de compra', sysdate()  );
/* 5: promocion por marca de zapatos - asignacion per multiple (factor multiplicador) dels punts de la compra realitzada */
INSERT INTO  ps_tipo_promo_esp_param ( id_tipo_promo_esp_param, ltDescrTipoPromo, fcUpd )
     VALUES ( 5, 'promocion por marca de zapatos - multiplo de compra', sysdate()  );
/* 6: promocion por modelo de zapatos - asignacion per multiple (factor multiplicador) dels punts de la compra realitzada */
INSERT INTO  ps_tipo_promo_esp_param ( id_tipo_promo_esp_param, ltDescrTipoPromo, fcUpd )
     VALUES ( 6, 'promocion por modelo de zapatos - multiplo de compra', sysdate()  );






/* 2º) alta de promociones concretas */
/* promocion 1: promocion por compra minima */
INSERT INTO  ps_punts_promo_esp_param ( id_punts_promo_esp_param, id_tipo_promo_esp_param, ltDescrPromo, fcIni, fcFin
                 , cdTipoValorControl, ltValorControlNUM, ltValorControlSTR, ltValorControlFEC
                 , nuPto_CLI1, nuPto_CLI2, nuPto_CLI3 , nuDiasCaduc_Pto_CLI1, nuDiasCaduc_Pto_CLI2, nuDiasCaduc_Pto_CLI3, fcUpd )
     VALUES ( 1, 1, 'promocion por compra minima', '2013-01-01', '2013-12-31'
                ,'NUM', 100, NULL, NULL , 1, 2, 5, 180, 180, 360, sysdate()  );

/* promocion 2: promocion por marca de zapatos */
INSERT INTO  ps_punts_promo_esp_param ( id_punts_promo_esp_param, id_tipo_promo_esp_param, ltDescrPromo, fcIni, fcFin
                 , cdTipoValorControl, ltValorControlNUM, ltValorControlSTR, ltValorControlFEC
                 , nuPto_CLI1, nuPto_CLI2, nuPto_CLI3 , nuDiasCaduc_Pto_CLI1, nuDiasCaduc_Pto_CLI2, nuDiasCaduc_Pto_CLI3, fcUpd )
     VALUES ( 2, 2, 'promocion por marca concreta de zapatos', '2013-02-01', '2013-05-31'
                ,'STR', NULL, 'ADIDAS', NULL , 1, 1, 3, 180, 180, 360, sysdate()  );
INSERT INTO  ps_punts_promo_esp_param ( id_punts_promo_esp_param, id_tipo_promo_esp_param, ltDescrPromo, fcIni, fcFin
                 , cdTipoValorControl, ltValorControlNUM, ltValorControlSTR, ltValorControlFEC
                 , nuPto_CLI1, nuPto_CLI2, nuPto_CLI3 , nuDiasCaduc_Pto_CLI1, nuDiasCaduc_Pto_CLI2, nuDiasCaduc_Pto_CLI3, fcUpd )
     VALUES ( 3, 2, 'promocion por marca concreta de zapatos', '2013-01-21', '2013-07-31'
                ,'STR', NULL, 'PANAMA JACK', NULL , 1, 1, 3, 180, 180, 360, sysdate()  );


/* promocion 5: promocion por marca de zapatos - multiplo de compra: el doble de punts per a tots tipus de clients */
INSERT INTO  ps_punts_promo_esp_param ( id_punts_promo_esp_param, id_tipo_promo_esp_param, ltDescrPromo, fcIni, fcFin
                 , cdTipoValorControl, ltValorControlNUM, ltValorControlSTR, ltValorControlFEC
                 , nuPto_CLI1, nuPto_CLI2, nuPto_CLI3 , nuDiasCaduc_Pto_CLI1, nuDiasCaduc_Pto_CLI2, nuDiasCaduc_Pto_CLI3, fcUpd )
     VALUES ( 4, 5, 'promocion por marca concreta de zapatos - por multiplo de compra', '2013-04-01', '2013-12-31'
                ,'STR', NULL, 'NIKE', NULL , 2, 2, 2, 180, 180, 360, sysdate()  );
INSERT INTO  ps_punts_promo_esp_param ( id_punts_promo_esp_param, id_tipo_promo_esp_param, ltDescrPromo, fcIni, fcFin
                 , cdTipoValorControl, ltValorControlNUM, ltValorControlSTR, ltValorControlFEC
                 , nuPto_CLI1, nuPto_CLI2, nuPto_CLI3 , nuDiasCaduc_Pto_CLI1, nuDiasCaduc_Pto_CLI2, nuDiasCaduc_Pto_CLI3, fcUpd )
     VALUES ( 5, 5, 'promocion por marca concreta de zapatos - por multiplo de compra', '2013-04-21', '2013-12-31'
                ,'STR', NULL, 'HUSH PUPPIES', NULL , 2, 2, 2, 180, 180, 360, sysdate()  );




/* tabla de gestion de puntos por cliente */
/* drop table ps_punts_clie; */
create table ps_punts_clie
 ( id_punts_clie int(10) AUTO_INCREMENT,  	/* identificador de esa obntencion de puntos del cliente: 
	el primer campo debe ser de tipo int(10), llamarse id_nombre_tabla (sin el ps_) y ser clave primaria y de tipo  AUTO_INCREMENT */
   id_customer int(10)  DEFAULT NULL,		/* identificacion del cliente */
   cdTipo_clie int(1)   DEFAULT NULL,		/* tipo de cliente: 1-ocasional, 2-habitual, 3-superconsumidor */
   fcObtencionPtos date  DEFAULT NULL,
   cdTipoObtencionPtos int(1)  DEFAULT NULL,    /* 1-Asignacion por compra
						 , 2-Asignacion por apadrinamiento
						 , 3-Asignacion por comentarios
						 , 4-Asignacion por cumpleaños
						 , 5-Asignacion por promocion especial */
   cdSubTipoObtencionPtos int(10)  DEFAULT NULL,  /* Solamente para tipo de obtencion 
					             2-Asignacion por apadrinamiento: 1-padrino, 2-apadrinado
						     o para 5-Asignacion por promocion especial: es el numero de la promocion especial
						     ... el resto de casos = NULL */
   id_order int(10)  DEFAULT NULL,  /* identificacion de la orden que provoca esta acumulacion de puntos 
			(solo para tipos 1-Asignacion por compra , 2-Asignacion por apadrinamiento )  */
   nuPtos  int(11)  DEFAULT NULL,
   nuDiasCaduc_Pto  int(11)  DEFAULT NULL,
   inPtosCanjeados char(1)  DEFAULT NULL,  /* S/N */
   fcPtosCanjedos date  DEFAULT NULL,      /* fecha de cuando se canjearon */
   inPtosDevueltos char(1)  DEFAULT NULL,  /* S/N */
   fcPtosDevueltos date  DEFAULT NULL,      /* fecha de cuando se devolvieron */
   ltDescrDevueltos CHAR(255)  DEFAULT NULL,  /* texto libre para comentar la devolucion de puntos */
   id_customer_relac int(10)  DEFAULT NULL,	/* id cliente relacionado en el apadrinamiento: 
					será el id del padrino (cuando cdTipoObtencionPtos=2 y cdSubTipoObtencionPtos=2
					   y el id del apadrinado (cuando cdTipoObtencionPtos=2 y cdSubTipoObtencionPtos=1)  
					y en el resto de casos será nulo  */
   id_comment char(255)  DEFAULT NULL,	/* identificador de comentario para el caso de asignacion de puntos por comentario (para control de duplicados)
					y en el resto de casos será nulo  */
   fcUpd datetime, 
   PRIMARY KEY (id_punts_clie)
   );

