<?php
/* ****************** clase ubicada en prestashop_1_4_5_1/admin99/tab  ****************************** */
include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');
/* **** y añado mi clase generica para tratar/gestionar los parametros de puntos ******** */
//require_once(PS_ADMIN_DIR.'/../classes/PuntsParam.php');
require_once(PS_ADMIN_DIR.'/../classes/PuntsGestion.php');
require_once(PS_ADMIN_DIR.'/../classes/PuntsPromoParam.php');



//habilitar el reporting de errores de php
//error_reporting(E_ALL);
//ini_set("display_errors", 1);


class AdminPuntsGestionDevol extends AdminTab
{
  /** @var array profiles list */
  private $profilesArray = array();

  public function __construct()
	{

		////echo "---->probanmdooooooooooo construct AdminPuntsGestionDevol ".date('Y-m-d H:i:s');

	 	global $cookie;

	 	$this->table = 'punts_clie';
		$this->className = 'PuntsClie';   /* debe existir en /classes */
	 	$this->lang = false;
	 	$this->edit = true;
	 	///$this->delete = true;
		$this->delete = false;		/* en este caso no se debe permitir eliminar regs; solamente modificar y añadir */


		///// TODAVIA EN PRUEBASSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS******************************
		/* ejemplo de join con la tabla de clientes para añadir email que permita la búsqueda/filtrado */
		//// right join
 		////$this->_select = ' c.firstname,c.lastname,c.email,c.id_customer as id_customer_orig ';
		////$this->_join = ' RIGHT JOIN '._DB_PREFIX_.'customer c ON a.id_customer = c.id_customer ';
		//// inner join
 		$this->_select = ' c.firstname,c.lastname,c.email,c.id_customer as id_customer_orig  ';
		$this->_join = ' INNER JOIN '._DB_PREFIX_.'customer c ON a.id_customer = c.id_customer ';

		///// filtrado por $idclienteBuscado
		/////$this->_where = ' and id_customer = '. $idclienteBuscado .' ';

		$profiles = Profile::getProfiles((int)($cookie->id_lang));
		if (!$profiles)
			$this->_errors[] = Tools::displayError('No profile');
		else
			foreach ($profiles AS $profile)
				$this->profilesArray[$profile['name']] = $profile['name'];

		/* a) crear cabeceras y campos para mostrar la tabla de puntos de los clientes */
		//$this->optionTitle = $this->l('Puntos de los clientes - gestion de devoluciones y tratamientos manuales de puntos');
		///echo '<h2>Puntos de los clientes - gestion de devoluciones y tratamientos manuales de puntos</h2>';
		echo '<h2>'. $this->l('Puntos de los clientes - gestion de devoluciones y tratamientos manuales de puntos') .'</h2>';


 	 	//lista de campos que se muestran en el listado (no tiene por qué coincidir con la lista completa de campos de la tabla)  	
		$this->fieldsDisplay = array(
		'id_punts_clie' => array('title' => $this->l('ID Punts'), 'align' => 'center', 'width' => 10),
		//// NOTA: No se puede mostrar en la lista el campo id_customer pues el mecanismo de filtrado falla 
		////       al tratarse del JOIN de dos tablas  (ps_punts_clie y ps_customer) con el mismo nombre de campo
		////'id_customer' => array('title' => $this->l('ID Clie'), 'align' => 'center', 'width' => 10),
		'cdTipo_clie' => array('title' => $this->l('Tipo Clie'), 'align' => 'center', 'width' => 10),
		'fcObtencionPtos' => array('title' => $this->l('Fecha ptos'), 'align' => 'center', 'width' => 40),
		'cdTipoObtencionPtos' => array('title' => $this->l('Tipo ptos'), 'align' => 'center', 'width' => 20),
		'cdSubTipoObtencionPtos' => array('title' => $this->l('Subtipo ptos'), 'align' => 'center', 'width' => 20),
		'id_order' => array('title' => $this->l('ID order'), 'align' => 'center', 'width' => 20),
		'nuPtos' => array('title' => $this->l('Ptos Clie'), 'align' => 'center', 'width' => 20),
		////dato no necesario presentar en la lista inicial: 
		////  'nuDiasCaduc_Pto' => array('title' => $this->l('Dias Caduc Ptos'), 'align' => 'center', 'width' => 20),
		'inPtosCanjeados' => array('title' => $this->l('Ptos Canj')    , 'align' => 'center', 'width' => 4),
		////dato no necesario presentar en la lista inicial: 
		////  'fcPtosCanjedos' => array('title' => $this->l('Fecha ptos canj'), 'align' => 'center', 'width' => 40),
		'inPtosDevueltos' => array('title' => $this->l('Ptos dev')    , 'align' => 'center', 'width' => 4),
		'fcPtosDevueltos' => array('title' => $this->l('Fecha ptos dev'), 'align' => 'center', 'width' => 40),
		'ltDescrDevueltos' => array('title' => $this->l('Descr dev'), 'align' => 'center', 'width' => 40),
		'id_customer_relac' => array('title' => $this->l('ID Clie relac'), 'align' => 'center', 'width' => 20),
		////dato no necesario presentar en la lista inicial: 
		////  'id_comment' => array('title' => $this->l('ID comment'), 'align' => 'center', 'width' => 20),
		////dato no necesario presentar en la lista inicial: 
		////  'fcUpd' => array('title' => $this->l('fecha update datos'), 'align' => 'center', 'width' => 40), 
		//
		// datos adicionales (join) de la tabla de datos del cliente 
		'firstname' => array('title' => $this->l('nom Clie'), 'align' => 'center', 'width' => 20),
		'lastname' => array('title' => $this->l('apell Clie'), 'align' => 'center', 'width' => 20),
		'email' => array('title' => $this->l('email Clie'), 'align' => 'center', 'width' => 40),
		////'id_customer_orig' => array('title' => $this->l('ID Clie orig'), 'align' => 'center', 'width' => 10),

		);
		

		// llamada al constructor
		parent::__construct();

		//poner resumen de totales por tipo de cliente
		
		$numTotClie = PuntsGestion::getTotalClie();
		$numTotClie_1 = PuntsGestion::getTotalPorTipoClie(1);
		$numTotClie_2 = PuntsGestion::getTotalPorTipoClie(2);
		$numTotClie_3 = PuntsGestion::getTotalPorTipoClie(3);
		$numTotClie_SIN = $numTotClie - ( $numTotClie_1 + $numTotClie_2 + $numTotClie_3 );
		//calculo del factor multiplicador para reescalado de hasta 240 posiciones graficas
		$nuFactorEscala = floor( 240 / $numTotClie );

		$numTotClie_1_escalado = $numTotClie_1 * $nuFactorEscala;
		$numTotClie_2_escalado = $numTotClie_2 * $nuFactorEscala;
		$numTotClie_3_escalado = $numTotClie_3 * $nuFactorEscala;
		$numTotClie_SIN_escalado = $numTotClie_SIN * $nuFactorEscala;

		//echo "<br>num clientes = ". $numTotClie;
		//echo "<br>num clientes tipo 1 = ". $numTotClie_1;
		//echo "<br>num clientes tipo 2 = ". $numTotClie_2;
		//echo "<br>num clientes tipo 3 = ". $numTotClie_3;
		//echo "<br>num clientes SIN compras por puntos = ". $numTotClie_SIN;
		//echo "<br>";		
		echo "<TABLE BORDER='0'>";
		echo "<TR>";
		echo "  <TD>Resumen totales: &nbsp</TD>";
		echo "  <TD BGCOLOR='#A67D3D'><FONT COLOR='#A67D3D'>";  // BRONZE color para clientes tipo 1
			for ($i = 1; $i <= $numTotClie_1_escalado; $i++) { echo "&nbsp"; }
		echo "  </FONT></TD>";
		echo "  <TD BGCOLOR='#C0C0C0'><FONT COLOR='#C0C0C0'>";  // SILVER color para clientes tipo 3
			for ($i = 1; $i <= $numTotClie_2_escalado; $i++) { echo "&nbsp"; }
		echo "  </FONT></TD>";
		echo "  <TD BGCOLOR='#D4A017'><FONT COLOR='#D4A017'>";  // GOLD color para clientes tipo 3
			for ($i = 1; $i <= $numTotClie_3_escalado; $i++) { echo "&nbsp"; }
		echo "  </FONT></TD>";
		echo "  <TD BGCOLOR='#555555'><FONT COLOR='#555555'>";  // BLACK color para clientes SIN compras con puntos
			for ($i = 1; $i <= $numTotClie_SIN_escalado; $i++) { echo "&nbsp"; }
		echo "  </FONT></TD>";
		echo "</TR>";
		echo "<TR>";
		echo "  <TD> </TD>";
		echo "  <TD>";
		echo "  <center><b>".$numTotClie_1."</center>";
		echo "  </TD>";
		echo "  <TD>";
		echo "  <center><b>".$numTotClie_2."</center>";
		echo "  </TD>";
		echo "  <TD>";
		echo "  <center><b>".$numTotClie_3."</center>";
		echo "  </TD>";
		echo "  <TD>";
		echo "  <center><b>". $numTotClie_SIN ." (sin ptos)</center>";
		echo "  </TD>";
		echo "</TR>";
		echo "</TABLE><br>"; 

	}




  public function displayForm($isMainTab = true)
	{

		global $currentIndex, $cookie;
		parent::displayForm();

		if (!($obj = $this->loadObject(true)))
			return;
		$profiles = Profile::getProfiles((int)($cookie->id_lang));

		echo '<script type="text/javascript" src="'._PS_JS_DIR_.'/jquery/jquery-colorpicker.js"></script>
		 	 <script type="text/javascript">
				var employeePage = true;
		 	 </script>';
	

		//tipo cliente
		$tipocliente = '';
		switch  ($this->getFieldValue($obj, 'cdTipo_clie')) 
			{ case 1:
			     $tipocliente = "-consumidor ocasional";
			     break;
			  case 2:
			     $tipocliente =  "-consumidor habitual";
			     break;
			  case 3:
			     $tipocliente =  "-superconsumidor";
			     break;
			};

		// formulario para la modificacion de un registro de la tabla 
		echo '<form action="'.$currentIndex.'&submitAdd'.$this->table.'=1&token='.$this->token.((int)$this->tabAccess['view'] ? '' : '&updatepuntsclie&id_punts_clie='.(int)$obj->id)
		.'" method="post" enctype="multipart/form-data" autocomplete="off">'
		.($obj->id ? '<input type="hidden" name="id_'.$this->table.'" value="'.$obj->id.'" />' : '')
		.' '.((int)$this->tabAccess['view'] ? '' : '<input type="hidden" name="back" value="'.$currentIndex.'&token='.$this->token.'&updatepuntsclie&id_punts_clie='.(int)$obj->id.'" />').'

			<!- /***** lista de campos de la tabla a modificar *****/ -->
			<fieldset class="width3"> 
				<legend><img src="../img/admin/nav-user.gif" />'.$this->l('punts_clie').'</legend>		
				<label>'.$this->l('ID cliente:').' </label>
				<div class="margin-form">					
					<input type="text" size="20" name="id_customer"
					  value="'.htmlentities($this->getFieldValue($obj, 'id_customer'), ENT_COMPAT, 'UTF-8').'" /> 
					<!-- cuando era dato no modificable: <h1>'.htmlentities($this->getFieldValue($obj, 'id_customer'), ENT_COMPAT, 'UTF-8').'</h1> -->
				<sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Tipo de cliente:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="cdTipo_clie" 
					  value="'.htmlentities($this->getFieldValue($obj, 'cdTipo_clie'), ENT_COMPAT, 'UTF-8').'" /> 
					<!-- cuando era dato no modificable: <h1>'.htmlentities($this->getFieldValue($obj, 'cdTipo_clie'), ENT_COMPAT, 'UTF-8').' '.$tipocliente.'</h1> -->
				</div><div class="clear">&nbsp;</div>

				<label>'.$this->l('Fecha de obtencion de los puntos:').' </label>
				<div class="margin-form">
					<input type="text" size="10" name="fcObtencionPtos" 
					  value="'.htmlentities($this->getFieldValue($obj, 'fcObtencionPtos'), ENT_COMPAT, 'UTF-8').'" />
					&nbsp;formato fecha AAAA-MM-DD
					<!-- cuando era dato no modificable: <h1>'.htmlentities($this->getFieldValue($obj, 'fcObtencionPtos'), ENT_COMPAT, 'UTF-8').'</h1> -->
				<sup>*</sup>
				</div><div class="clear">&nbsp;</div>				


				<label>'.$this->l('Tipo de obtencion de los puntos:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="cdTipoObtencionPtos" 
					  value="'.htmlentities($this->getFieldValue($obj, 'cdTipoObtencionPtos'), ENT_COMPAT, 'UTF-8').'" /> 
					<!-- cuando era dato no modificable: <h1>'.htmlentities($this->getFieldValue($obj, 'cdTipoObtencionPtos'), ENT_COMPAT, 'UTF-8').'</h1> -->
				<sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Subtipo de obtencion de los puntos:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="cdSubTipoObtencionPtos" 
					  value="'.htmlentities($this->getFieldValue($obj, 'cdSubTipoObtencionPtos'), ENT_COMPAT, 'UTF-8').'" /> 
					<!-- cuando era dato no modificable: <h1>'.htmlentities($this->getFieldValue($obj, 'cdSubTipoObtencionPtos'), ENT_COMPAT, 'UTF-8').'</h1> -->
				<sup>*</sup>
				</div><div class="clear">&nbsp;</div>

				<label>'.$this->l('ID orden:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="id_order" 
					  value="'.htmlentities($this->getFieldValue($obj, 'id_order'), ENT_COMPAT, 'UTF-8').'" /> 
					<!-- cuando era dato no modificable: <h1>'.htmlentities($this->getFieldValue($obj, 'id_order'), ENT_COMPAT, 'UTF-8').'</h1> -->
				</div><div class="clear">&nbsp;</div>

				<label>'.$this->l('Puntos del cliente:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="nuPtos" 
					  value="'.htmlentities($this->getFieldValue($obj, 'nuPtos'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Caducidad en dias de los puntos:').' </label>
				<div class="margin-form">
					<input type="text" size="20" name="nuDiasCaduc_Pto" 
					  value="'.htmlentities($this->getFieldValue($obj, 'nuDiasCaduc_Pto'), ENT_COMPAT, 'UTF-8').'" /> 
					<sup>*</sup>
				</div><div class="clear">&nbsp;</div>

				<label>'.$this->l('Indicador (S/N) de puntos canjeados:').' </label>
				<div class="margin-form">
					<select name="inPtosCanjeados">  
						<option value="S" '
							.($this->getFieldValue($obj,'inPtosCanjeados') == "S" ? ' selected="selected"' : ' ')
							.'> SI </option>
						<option value="N" '
							.($this->getFieldValue($obj,'inPtosCanjeados') == "N" ? ' selected="selected"' : ' ')
							.'> NO </option>
					</select> <sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Fecha de canje de los puntos:').' </label>
				<div class="margin-form">
					<input type="text" size="10" name="fcPtosCanjedos" 
					  value="'.htmlentities($this->getFieldValue($obj, 'fcPtosCanjedos'), ENT_COMPAT, 'UTF-8').'" /> 
					&nbsp;formato fecha AAAA-MM-DD
				</div><div class="clear">&nbsp;</div>				


				<label>'.$this->l('Indicador (S/N) de puntos devueltos:').' </label>
				<div class="margin-form">
					<select name="inPtosDevueltos">  
						<option value="S" '
							.($this->getFieldValue($obj,'inPtosDevueltos') == "S" ? ' selected="selected"' : ' ')
							.'> SI </option>
						<option value="N" '
							.($this->getFieldValue($obj,'inPtosDevueltos') == "N" ? ' selected="selected"' : ' ')
							.'> NO </option>
					</select> <sup>*</sup>
				</div><div class="clear">&nbsp;</div>
				<label>'.$this->l('Fecha de devolucion de los puntos:').' </label>
				<div class="margin-form">
					<input type="text" size="10" name="fcPtosDevueltos" 
					  value="'.htmlentities($this->getFieldValue($obj, 'fcPtosDevueltos'), ENT_COMPAT, 'UTF-8').'" /> 
					&nbsp;formato fecha AAAA-MM-DD
				</div><div class="clear">&nbsp;</div> 
				<label>'.$this->l('Descripcion de la devolucion:').' </label>
				<div class="margin-form">
					<input type="text" size="40" name="ltDescrDevueltos" 
					  value="'.htmlentities($this->getFieldValue($obj, 'ltDescrDevueltos'), ENT_COMPAT, 'UTF-8').'" /> 
				</div><div class="clear">&nbsp;</div> 
				<label>'.$this->l('ID cliente relacionado (padrino/apadrinado) en apadrinamiento:').' </label>
				<div class="margin-form">
					<input type="text" size="10" name="id_customer_relac" 
					  value="'.htmlentities($this->getFieldValue($obj, 'id_customer_relac'), ENT_COMPAT, 'UTF-8').'" /> 
				</div><div class="clear">&nbsp;</div> 
				<label>'.$this->l('ID comentario en puntos por comentario:').' </label>
				<div class="margin-form">
					<input type="text" size="40" name="id_comment" 
					  value="'.htmlentities($this->getFieldValue($obj, 'id_comment'), ENT_COMPAT, 'UTF-8').'" /> 
				</div><div class="clear">&nbsp;</div> 				
				';


		//boton de guardar
		echo '<div class="clear">&nbsp;</div>
				<center>
					<input type="submit" value="'.$this->l('   Save   ').'" name="submitAdd'.$this->table.'" class="button" />
				</center><div class="clear">&nbsp;</div>
				<div class="small"><sup>*</sup> '.$this->l('Required field').'</div>
			</fieldset>
		</form>';
	}



public function postProcess()
	{

		global $cookie;


		if (Tools::isSubmit('deletepuntsclie') OR Tools::isSubmit('status') OR Tools::isSubmit('statuspuntsclie'))
		{
			if ($cookie->id_punts_clie == Tools::getValue('id_punts_clie'))
			{
				$this->_errors[] = Tools::displayError('You cannot disable or delete your own account.');
				return false;
			}

			$PuntsClie = new PuntsClie(Tools::getValue('id_punts_clie'));  /* debe existir la clase en /classes como una clase core */
			if ($PuntsClie->isLastAdmin())
			{
					$this->_errors[] = Tools::displayError('You cannot disable or delete the last administrator account.');
					return false;
			}
		}
		elseif (Tools::isSubmit('submitAddpuntspromoesp'))
		{
			$PuntsClie = new PuntsClie((int)Tools::getValue('id_punts_clie')); /* debe existir la clase en /classes como una clase core */
		}

		///echo "---->finalizandooooooo postProcess";
		return parent::postProcess();
	}

}
