<?php


 //habilitar el reporting de errores de php
 ///error_reporting(E_ALL);
 ///ini_set("display_errors", 1);


//class PuntsGestionCanjeController extends FrontController  ----> debe ser clase CORE
class PuntsGestionCanjeControllerCore  extends FrontController
{
	public $auth = true;
	public $php_self = 'PuntsGestionCanje.php';
	public $authRedirection = 'PuntsGestionCanje.php';
	public $ssl = true;
	
	public function process()
	{
		parent::process();
		
		//Consultar los puntos que tiene este cliente
		$misPuntos = PuntsGestion::getPtosByCli((int)(self::$cookie->id_customer), 1); 
		///echo "<br> (En process) Los puntos que tengo: ".$misPuntos ."<hr>";


		//solucion1: parametros pasados en la URL de llamada
		//recoger y tratar parametros de llamada
		$param = getenv("QUERY_STRING");

		//control para la version de grandeszapatos que añade parametros en la llamada
		//control para la version de grandeszapatos que añade parametros en la llamada
		$posSimbolo1 = strrpos($param,"&");		
		if ( $posSimbolo1 != false && $posSimbolo1 >= 0 )
			{
			$param = substr($param,$posSimbolo1+1);
			};
		$posSimbolo2 = strrpos($param,"=");		
		if ( $posSimbolo2 != false && $posSimbolo2 >= 0 )
			{
			$param = substr($param,0,strlen($param)-1);
			};
		
		///echo "<hr><hr> ------->param = ". $param ."<hr>";
		//crear el array de parametros (el primero es el usuario, y el resto la lista de id_puntos a canjear)
		$arrayParam = explode('_', $param);

		//mostrar datos segun solucion 1 (datos pasados por URL)
		//echo "<br>SOLUCION1: ------>cliente ".$arrayParam[0]."<br>";
		//print_r($arrayParam);
		//echo "<hr>";


		//solucion2: parametros pasados en forma de cookies
		//recoger y tratar parametros de llamada
		$numParam = $_COOKIE["numParam_cookie"];
		$idClienteActual = $_COOKIE["idCliente_cookie"];
		$param = $idClienteActual;
		for ( $i=1; $i <= $numParam; $i++) 
			{
			$param = $param ."_". $_COOKIE["idPuntsClie_cookie".$i];
			};
		//echo "<hr><hr> ------->param = ". $param ."<hr>";
		//crear el array de parametros (el primero es el usuario, y el resto la lista de id_puntos a canjear)
		$arrayParam = explode('_', $param);

		//mostrar datos: segun solucion 2 (datos pasados por cookies)
		//echo "<br>SOLUCION2: ------>cliente ".$arrayParam[0] ."   numParam = ".$numParam ."<br>";
		//print_r($arrayParam);
		//echo "<hr>";



		//ejemplo de llamada a metodos sde la clase:
		//echo " tiene puntos=".PuntsGestion::getPtosByCli($arrayParam[0],1);


		//llamada al metodo de canje de puntos
		$misPuntosCanjeados = PuntsGestion::setCanjeaPtosByDiscounts($arrayParam[0],$arrayParam);
		
		//meter algunos datos en variables smarty para presentarlos en pantalla
		self::$smarty->assign(array(
			'idCliente' => (int)($arrayParam[0]),
			'misPuntos' => $misPuntos,
			'misPuntosCanjeados' => (int)($misPuntosCanjeados)
		));

	}
	
	public function displayContent()
	{
		parent::displayContent();		
		self::$smarty->display(_PS_THEME_DIR_.'PuntsGestionCanje.tpl');
	}
}

