<?php
/* ****************** clase ubicada en prestashop_1_4_5_1/classes  ****************************** */


class PuntsClie extends ObjectModel
{
	public 		$id;

	/* vars de la tabla ps_punts_clie (excepto la usada como clave: id_punts_promo_esp_param) */
	public   	$id_customer;
	public   	$cdTipo_clie;
	public   	$fcObtencionPtos;
	public   	$cdTipoObtencionPtos;
	public   	$cdSubTipoObtencionPtos;
	public   	$id_order;
	public   	$nuPtos;
	public   	$nuDiasCaduc_Pto;
	public   	$inPtosCanjeados;
	public   	$fcPtosCanjedos;
	public   	$inPtosDevueltos;
	public   	$fcPtosDevueltos;
	public   	$ltDescrDevueltos;
	public   	$id_customer_relac;
	public   	$id_comment;
	public   	$fcUpd;


	protected 	$table = 'punts_clie';  /* tabla */
	protected 	$identifier = 'id_punts_clie';   /* clave de la tabla */

/***	protected	$webserviceParameters = array();
***/


	public	function getFields()
	{
	 	//parent::validateFields();

		$fields['id_customer'] = pSQL($this->id_customer);	
		$fields['cdTipo_clie'] = pSQL($this->cdTipo_clie);
		$fields['fcObtencionPtos'] = pSQL($this->fcObtencionPtos);
		$fields['cdTipoObtencionPtos'] = pSQL($this->cdTipoObtencionPtos);
		$fields['cdSubTipoObtencionPtos'] = pSQL($this->cdSubTipoObtencionPtos);
		$fields['id_order'] = (int)pSQL($this->id_order);
		$fields['nuPtos'] = (int)pSQL($this->nuPtos);
		$fields['nuDiasCaduc_Pto'] = (int)pSQL($this->nuDiasCaduc_Pto);
		$fields['inPtosCanjeados'] = pSQL($this->inPtosCanjeados);
		$fields['fcPtosCanjedos'] = pSQL($this->fcPtosCanjedos);
		$fields['inPtosDevueltos'] = pSQL($this->inPtosDevueltos);
		//if (empty($this->fcPtosDevueltos))
		//	$this->fcPtosDevueltos = date('Y-m-d 00:00:00');
		$fields['fcPtosDevueltos'] = pSQL($this->fcPtosDevueltos);
		$fields['ltDescrDevueltos'] = pSQL($this->ltDescrDevueltos);
		$fields['id_customer_relac'] = pSQL($this->id_customer_relac);
		$fields['id_comment'] = pSQL($this->id_comment);
		if (empty($this->fcUpd))
			$this->fcUpd = date('Y-m-d 00:00:00');

		return $fields;
	}

	//public function add($autodate = true, $nullValues = false)
	public function add($autodate = true, $nullValues = true)
	{
		//echo "<hr><hr>*************TOI EN ADD ********************";
		return parent::add($autodate, $nullValues);
	}


	public function delete()
	{
		//echo "<hr><hr>*************TOI EN DELETE ********************";
		return parent::delete();
	}


}
